/*   imgsize.c   */
/*   jjk   */
/*   01-15-90   */

/*  C function to get image size and datatype from header (from
	imfort library subroutine call)   */
/*   assumes 2-d images  */
/*   Note:  This function needs the address of the struct IMAGE  */
/*   10-02-90:  Added a second arguement, that copies the image
		structure.  */
/*   07-14-92:  made it so that pixtype has to be FLOAT.  Although I
		think this is desirable for all things that are likely
		to use this, it would be nicer to accept any type and
		convert it to real  */

#include <stdio.h>
#include "imiraf.h"

struct IMAGE imgsize(im, img)
    int im;
    struct IMAGE img;
{
    int ier, axlen[7], naxis, pixtype;
    char *imemsg();
    struct IMAGE image;

    image=img;
    imgsiz_(&im, axlen, &naxis, &pixtype, &ier);
    if(ier)
	error("IMGSIZE:  %s\n", imemsg(ier));
    if(naxis!=2)
	error("Only 2-d images supported\n");
    else
    {
	image.cols= *axlen;
	image.rows=*(axlen + 1);
	if((image.pixtype=pixtype)!=FLOAT)
	    error("IMGSIZE:  pixel type must be real\n");
    }
    return(image);
}
