/*   imps2r.c   */
/*   jjk   */
/*   02-01-90   */

/*  C function to get an image section (from imfort library subroutine
	call)  */
/*   01-15-90:  for some reason, I have to use the intermediate i and
		j variables
		It is also important to note that this uses the
		image.box substructure and not the whole image
		and that image.pixels should point to the subraster,
		which can be but isn't necessarily the whole image */
/*   02-10-90:  this is apparently slower than impl2r()   */
/*   04-07-91:  defaults to entire image if image.box not set 
		(actually, if they are zero, which will be the usual
		case).   */

#include <stdio.h>
#include "imiraf.h"

imps2r(im, image)
    int im;
    struct IMAGE image;
{
    int ier, i1, i2, j1, j2;
    char *imemsg();

    i1=image.box.x1;
    i2=image.box.x2;
    j1=image.box.y1;
    j2=image.box.y2;
    if(!i1 && !i2 && !j1 && !j2)
    {
	i1=j1=1;
	i2=image.cols;
	j2=image.rows;
    }
    if(image.box.x1>image.box.x2)
	error("IMPS2R:  x2>x1\n");
    imps2r_(&im, image.pixels, &i1, &i2, &j1, &j2, &ier);
    if(ier)
	printf("IMPS2R:  %s\n", imemsg(ier));
    return(ier);
}
