/*   dblent.c  */
/*   written by Stephen Levine and Jim Klavetter   */
/*   08-15-85  */

/*
 *   21 Aug 1986: sel - changed %lf in printf to %.16g to allow easier
 *			display of very large and very small numbers.
 *
 *   8 mar 1986: changed to allow retention of old value if just
 *			a <RETURN> is entered. Also made even
 *			smarter in terms of error catching.
 *
 *   03-05-86:  extensively modified to be much smarter with errors
 *		so as to be actually useful
 */

#define OK 1
#define BAD 0
#include <stdio.h>
#include <ctype.h>

double  dblent (prompt, number)
double  number;
char   *prompt[];
{
    char    value[25];
    int     i = 0;
    int     j = 0;
    int     k;
    int     errflag,
            eflag,
            decflag;
    double  atof ();

    do {
	if (j++) {
	    for (j = 0; j < 25; j++)
		value[j] = '\0';
	    printf ("Bad character, try again.  ");
	    i = 0;
	}
/* Entry prompt			*/
	printf ("%s [%.16g] (double) : ", prompt, number);
	while ((value[i] = getchar ()) != '\n') {
/*
 debugging printf
	    printf ("rdbent: value[%d] = %c\n", i, value[i]);
*/
	    if((isspace(value[i])) == 0)
	   	 i++;
	}
	if (i == 0)
	    break;
/*
 *		Entry error checking portion
 *			make sure that there is only one decimal
 *			point and only one 'e' or 'E'. Also that
 *			the - or + sign comes at the beginning
 *			of the number or exponent.
 */
	decflag = 0;
	eflag = 0;
	for (k = 0; k < i; k++) {
	    if ((errflag = isdigit (value[k])) == BAD) {
		if ((value[k] == '-') || (value[k] == '+') || (value[k] == '.')
			|| (value[k] == 'e') || (value[k] == 'E')) {
		    if ((k == 0) && ((value[k] == '-') || (value[k] == '+')))
			errflag = OK;
		    else
			if ((k != 0) && ((value[k] == '-') ||
				    (value[k] == '+')) &&
				((value[k - 1] == 'e') ||
				    (value[k - 1] == 'E')))
			    errflag = OK;
			else
			    if (((value[k] == 'e') || (value[k] == 'E'))
				    && (eflag == 0) && (k != 0) &&
				    (isdigit(value[k-1]) != 0)) {
				errflag = OK;
				eflag = 1;
			    }
			    else
				if ((value[k] == '.') && (decflag == 0)) {
				    errflag = OK;
				    decflag = 1;
				}
				else
				    break;
		}
		else
		    break;
	    }
	}
    } while (errflag == BAD);

/*    printf ("rdbent:  %f\n", atof (value));	*/

/*	if entry was a <RET>, return old number
 *	otherwise, return new number
 */
    if (i == 0)
	return (number);
    else
	return (atof (value));
}
