/*  gauss()
    07-08-86
    Author: Jack Wisdom

    Generates Gaussian random numbers with mean=0 and sigma=1.

    Calling seqyence:
         val = gauss(seed);

    Parameters:
         seed  on input, arbitrary integer seed for UNIX
	       srand() function.
	       integer seed

	 val   on output, Gaussian random number.

    Revisions:
    01-12-87: Inserted check that x1=0 for every return from 
		rand() [DC]

*/

#include <math.h>
#include "localmath.h"

double gauss(seed)
     int seed;
{
  static int flag=0;
  static double xsave;

  double r, x, x1, x2;

  if(flag == 0 ) srand(seed);

  if(flag>=0)
    {
      x2=(double)rand()/2147483647.0;  /* 2^31 - 1 */
      x1=(double)rand()/2147483647.0;  /* 2^31 - 1 */
      while(x1==0.)
	x1=(double)rand()/2147483647.0;  /* 2^31 - 1 */
      r=sqrt(-2.0*log(x1));
      x=r*cos(TWOPI*x2);
      xsave=r*sin(TWOPI*x2);
      flag= -1;
    }
  else
    {
      x=xsave;
      flag=1;
    }
  return(x);
}
