/*
 *	h_to_hms
 *	subroutine to convert hh.hhhh (hours) to
 *	hh.mmssss
 *	written by Stephen Levine - mit optical astronomy group
 *		on 8 march 1986
 *
 *	revisions: 27 may 1986 re-fix rounding error
 *			6 april 1986 fixed rounding error
 */
#include <math.h>

double h_to_hms(hours)
double hours;
{
	int newh, newm;
	int news;
	double minu, hms;

	hours = hours + 0.0000005;

	newh = (int)(hours);
	minu = (hours - newh)*60.;
	newm = (int)(minu);
	news = (int)( (minu - (int)(minu))*60. * 100.);

/* DEBUGGING
	printf("h_to_hms: newm = %d\tnews = %d\n",newm, news);
*/

	hms = newh + newm/100. + news/1000000.;
	return(hms);
}
