/*
 *	hms_to_h
 *	subroutine to convert hh.mmssss  to
 *	hh.hhhh (hours).
 *	written by Stephen Levine - mit optical astronomy group
 *		on 8 march 1986
 *
 *	revision:      27 may 1986 re-fix rounding error
 *			6 april 1986 fixed rounding error
 */
#include <math.h>

double hms_to_h(hminsec)
double hminsec;
{
	int newh, newm, news;  
	double minu, hhh;

	hminsec = hminsec + 0.0000005;

	newh = (int)(hminsec);
	minu = (hminsec - newh)*100.;
	newm = (int)(minu);
	news = (int)( (minu - (int)(minu))*10000.);

/*	DEBUGGING
	printf("hms_to_h: newh = %d\tminu = %f\tnewm = %d\tnews = %d\n",newh,
				minu,newm,news);
*/

	hhh = newh + newm/60. + news/360000.;
	return(hhh);
}
