/*START*/
/*TITLE int_check */
/*
Source File : /usr/local/utility/src/int_check.c
Author(s) : Stephen Levine
Latest Version: 6/27/86

Description : allows integer entry with boundary checking

Algorithm : 

Calling Sequence : new_number =int_check(prompt,number,lower_bound,upper_bound);

Parameter(s) : prompt - char array with entry prompt
		number - integer which is last value in field
		lower_bound - integer
		upper_bound - integer

Returned Value(s) : new_number - integer is new number (or number if <RET>
			was entered

Routines Called : intent, and the stdio library

Bugs and Restrictions : <give known problems, suggested improvements, etc.> 

See also :  /usr/local/utility/intent.c

Revisions :  <Give date, your name or initials, and brief description of
		the revision.  List most recent revision first.  If the change
		is subtle or risky, comment out the code you modified and
		make a note about what you did.>
*/
/*FINISH*/

#include <stdio.h>
#include <math.h>

int_check(prompt,number,lower_bound,upper_bound)
char *prompt[];
int number, lower_bound, upper_bound;
{
	int i = 0;
	int new_number;
	do{
		if(i > 0)
			printf("int_check: entry out of bounds\n");
		new_number = intent(prompt,number);
		i++;
	} while((new_number > upper_bound) || (new_number < lower_bound));

	return(new_number);
}
