/*   minmax.c   */
/*   jjk   */
/*   06-25-90   */

/*   returns a minmax structure containing min and max from an array
	of floats (because IRAF doesn't support doubles).
	NOTE:  the positions returned are zero based.  */

#include <math.h>
#include "minmax.h"

struct MINMAX minmax(buf, nobj)
    int nobj;
    float *buf;
{
    register i;
    register float temp;
    struct MINMAX extreme;

/*printf("MINMAX:  %f %d\n", *buf, nobj);  */
    extreme.max=extreme.min=*buf;
    extreme.maxpos=extreme.minpos=0;
    for(i=0; i<nobj - 1; i++)
    {
	temp=*++buf;
	if(temp>extreme.max)
	{
	    extreme.max=temp;
	    extreme.maxpos=i + 1;
	}
	if(temp<extreme.min)
	{
	    extreme.min=temp;
	    extreme.minpos=i + 1;
	}
    }
    return(extreme);
}
