/*   smooth.c   */
/*   jjk   */
/*   06-24-90   */

/*   smooth a vector.  simple running average of navg points  */

/*  input is a character pointer to the buffer, the size of each 
	object (use sizeof(type)), the number of objects, the
	number of points to average, and an option to wrap around
	(wrapflag=1) or if not (=0), then to just use the value
	with not averaging at the ends.
	Always returns a float pointer.  */
/*   06-24-90:  Couldn't get it to work with generic size, so 
		changed it so that buf must be pointer to float */
/*   04-06-91:  Rather than a straight average, I weight the middle
		values of pixels around navg in a manner similar to
		Bevington (but I extend it to any N)  */

#include <stdio.h>

float *smooth(buf, nobj, navg, wrapflag)
    float *buf;
    int nobj, navg, wrapflag;
{
    register i, j;
    int sflag=1;
    float *rbuf;
    double sum, num, denom;
    char *malloc();

/*printf("%f %d %d %d\n", *buf, nobj, navg, wrapflag);  */
    if(navg<2)
    {
	warn("SMOOTH makes no sense with navg<2...");
	return;
    }
    if(navg%2==0)
    {
	warn("SMOOTHing done for odd n only, increasing n by one\n");
	navg++;
    }
    if((rbuf=(float *)malloc(nobj*sizeof(float)))==NULL)
	error("MALLOC\n");
    denom=(double)((navg/2 + 1)*(navg/2 + 1));
    for(i=0; i<nobj; i++)
    {
	num=0.;
	sum=0.;
	if(i - navg/2>=0 && i + (navg - 1)/2<nobj)
	{
	    sflag=1;
	    for(j=i - navg/2; j<=i + (navg - 1)/2; j++)
	    {
		if(num<(double)(navg/2 + 1) && sflag)
		    num+= 1.;
		else
		{
		    num-=1.;
		    sflag=0;
		}
		sum+=num*(double)*(buf + j)/denom;
	    }
	}
	else if(wrapflag)
	{
	    sflag=1;
	    for(j=i - navg/2; j<=i + (navg - 1)/2; j++)
	    {
		if(num<(double)(navg/2 + 1) && sflag)
		    num+= 1.;
		else
		{
		    num-=1.;
		    sflag=0;
		}
		sum+=(double)*(buf + (j + nobj)%nobj);
	    }
	}
	else
	    sum=(double)*(buf + i);
        *rbuf++=(float)sum;
/*printf("smooth:  %d %d %f %f\n", i, j, *(rbuf-1), *(buf + i));  */
    }
    free(rbuf);
    return(rbuf - nobj);
}
