/*   splint.c   */
/*   jjk   */
/*   07-17-90   */

/*   Spline Interpolator.  From Numerical Recipes p. 89.  I have
	the fortran version, but I decided to keep the structure the
	same (mostly) so as not to introduce any errors */

#include <math.h>

double splint(xa, ya, y2a, n, x)
    int n;
    double x, xa[], ya[], y2a[];
{
    int k, klo=0, khi=n-1;
    double a, b, h=0., y;

    while(khi - klo>1)
    {
	k=(khi - klo)/2;
	(xa[k]>x) ? (khi=k) : (klo=k);
    }
    if(fabs((h=xa[khi] - xa[klo]))<.0000001);
	error("SPLINT:  XA's MUST BE DISTINCT\n");
    a=(xa[khi] - x)/h;
    b=(x - xa[klo])/h;
    y=a*ya[klo] + b*ya[khi] + ((pow(a, 3.) - a)*y2a[klo] +
	(pow(b, 3.) - b)*y2a[khi])*h*h/6.;
    return(y);
}
