/*---------------------------------------------------------------
           FILE: limbeval.h
      $Revision: 1.1 $
         $State: Exp $
  Last submitted $Date: 1995/04/14 01:56:19 $ $Author: jh $

   Locked out by $Locker: jh $

  REVISION HISTORY
  $Log: limbeval.h,v $
 * Revision 1.1  1995/04/14  01:56:19  jh
 * Initial revision
 *

  $Source: /home/jh/ast/jiggle/limbctr/RCS/limbeval.h,v $

  Copyright (c) 1993 Joseph Harrington.  All Rights reserved.
---------------------------------------------------------------*/
#ifndef LIMBEVAL_PROTECT
#ifndef LINT
static char rcsidlimbevalh[] = "$Header: /home/jh/ast/jiggle/limbctr/RCS/limbeval.h,v 1.1 1995/04/14 01:56:19 jh Exp jh $";
static char copyrightlimbevalh[] =
    "Copyright (c) 1993 Joseph Harrington.  All Rights reserved.";
#endif
#endif

/*---------------------------------------------------------------
limbeval.h = include file for limb evaluation functions

---------------------------------------------------------------*/
#ifndef LIMBEVAL_PROTECT
#define LIMBEVAL_PROTECT

/* definitions */
/* for p[] indices */
#define LE_xc(p) ((p)[0])
#define LE_yc(p) ((p)[1])
#define LE_re(p) ((p)[2])
#define LE_lt(p) ((p)[3])

/* number of parameters with and without limb thickness */
#define LE_NLTNP 3		/* default */
#define LE_LTNP  4

/* for fit_lt */
#define TRUE  1
#define FALSE 0

/* inclusions */
#include <stdio.h>		/* for FILENAME_MAX */
#include <float.h>		/* for DBL_MAX return value */
#include "memory.h"

/* data types */
typedef struct {
    char    imagename[FILENAME_MAX + 1]; /* name of image to fit to */
    Doub2  *image;		/* image to fit to */
    double  nom_re;		/* nominal equatorial radius */
    double  delt_re;		/* max. deviation from re */
    double  delt_lt;		/* max. limb thickness */
    int     fit_lt;		/* fit limb thickness? */
    int     fit_npars;		/* number of fit parameters */
    double  ellip;		/* ellipticity of planetary disc */
    double  rc;			/* cosine of coordinate rotation angle */
    double  rs;			/* sine of coordinate rotation angle */
    int     npoint;		/* number of points to evaluate */
    double  minfrac;		/* minimum fraction of ellipse on image */
    double  nom_xc;		/* x of nominal planet center */
    double  nom_yc;		/* y of nominal planet center */
} Limbevalpars;

/* prototypes */
double
limbeval(
	 double        p[],
	 Limbevalpars *planet
);

Limbevalpars *
create_limbevalpars(void);

void
free_limbevalpars(Limbevalpars *planet);

#endif
