/*---------------------------------------------------------------
           FILE: memory.h
      $Revision: 2.0 $
         $State: Exp $
  Last submitted $Date: 93/03/30 18:06:18 $ $Author: jh $

   Locked out by $Locker: jh $

  REVISION HISTORY
  $Log:	memory.h,v $
 * Revision 2.0  93/03/30  18:06:18  jh
 * Actual first release version.
 * 
 * Revision 1.2  93/03/30  13:55:46  jh
 * General code cleanup, testing, and added features.
 * First release version.
 * 
 * Revision 1.1  92/12/15  13:12:32  jh
 * Initial revision
 * 

  $Source: /u3/jh/jupobs92/anal/iraf/src/jiggle/RCS/memory.h,v $

  Copyright (c) 1992, 1993 Joseph Harrington.
  All Rights reserved.
---------------------------------------------------------------*/
#ifndef MEMORY_PROTECT
#ifndef LINT
static char rcsidmemoryh[] = "$Header: /u3/jh/jupobs92/anal/iraf/src/jiggle/RCS/memory.h,v 2.0 93/03/30 18:06:18 jh Exp Locker: jh $";
static char copyrightmemoryh[] =
    "Copyright (c) 1992, 1993 Joseph Harrington.  All Rights reserved.";
#endif
#endif

/*---------------------------------------------------------------
memory.h = include file for memory allocation
---------------------------------------------------------------*/
#ifndef MEMORY_PROTECT
#define MEMORY_PROTECT

/* definitions */
#define SUCCESS 1
#define FAILURE 0

/* inclusions */
#include <stddef.h>

/* data types */

typedef struct {
    size_t   ni;
    size_t   nj;
    double **data;
} Doub2;

typedef struct {
    size_t   ni;
    size_t   nj;
    size_t **data;
} Size_T2;

typedef struct {
    size_t    ni;
    size_t    nj;
    Doub2  ***data;
} Doub2p2;

typedef struct {
    size_t    ni;
    size_t    nj;
    size_t    nk;
    char   ***data;
} Char3;

/* prototypes */

#if defined(__STDC__) || defined(__cplusplus)
# define P_(s) s
#else
# define P_(s) ()
#endif


/* memory.c */
Doub2 *alloc_doub2 P_((size_t ni, size_t nj));
double **alloc_arrdoub2 P_((size_t ni, size_t nj));
void free_arrdoub2 P_((double **m));
void free_doub2 P_((Doub2 *m));
Size_T2 *alloc_size_t2 P_((size_t ni, size_t nj));
size_t **alloc_arrsize_t2 P_((size_t ni, size_t nj));
void free_arrsize_t2 P_((size_t **m));
void free_size_t2 P_((Size_T2 *m));
Doub2p2 *alloc_doub2p2 P_((size_t ni, size_t nj));
Doub2 ***alloc_arrdoub2p2 P_((size_t ni, size_t nj));
void free_arrdoub2p2 P_((Doub2 ***m));
void free_doub2p2 P_((Doub2p2 *m));
int alloc_arrdoub2p2elts P_((Doub2 ***m, size_t ni, size_t nj, size_t ny, size_t
 nx));
void free_arrdoub2p2elts P_((Doub2 ***m, size_t ni, size_t nj));
Char3 *alloc_char3 P_((size_t ni, size_t nj, size_t nk));
char ***alloc_arrchar3 P_((size_t ni, size_t nj, size_t nk));
void free_arrchar3 P_((char ***m));
void free_char3 P_((Char3 *m));

#undef P_

#endif
