/*---------------------------------------------------------------
           FILE: pltest.c
      $Revision: 1.1 $
         $State: Exp $
  Last submitted $Date: 1995/04/14 01:57:39 $ $Author: jh $

   Locked out by $Locker: jh $

  REVISION HISTORY
  $Log: pltest.c,v $
 * Revision 1.1  1995/04/14  01:57:39  jh
 * Initial revision
 *

  $Source: /home/jh/ast/jiggle/limbctr/RCS/pltest.c,v $

  Copyright (c) 1993 Joseph Harrington.  All Rights reserved.
---------------------------------------------------------------*/
#ifndef LINT
static char rcsid[] = "$Header: /home/jh/ast/jiggle/limbctr/RCS/pltest.c,v 1.1 1995/04/14 01:57:39 jh Exp jh $";
static char copyright[] =
    "Copyright (c) 1993 Joseph Harrington.  All Rights reserved.";
#endif
/*---------------------------------------------------------------
pltest.c = test program for planetary functions

External object files or libraries:

---------------------------------------------------------------*/
/* inclusions */
#include <stdio.h>
#include "planetmap.h"

/* definitions */

/* data types */

/* prototypes */

/*---------------------------------------------------------------
Effect:
Requires:
Modifies:
Implementation notes:
---------------------------------------------------------------*/
int
main(int argc, char *argv[]){
    int i;
    double radi[] = {-100., -2.*PI,  -5., -PI/2., 0.,
		     PI/2.,   5.,    2*PI,  100.};
    double degi[] = {-5729.5780, -360., -286.4789, -90., 0.,
		     90.,   286.4789, 360., 5729.5780};
    double degcdi[] = {0., 37., 90., 143.,  180., 217., 270., 307., 360.};
    double deg;
    double degm;
    double rad;
    double radm;
    double cen;
    double det;
    double tor;

    printf("Angle measure tests:\n");
    printf("     rad   PMdegrees(rad) PMdegrng(deg)   deg       PMradians(deg)  PMradrng(rad)\n");
    for ( i = 0 ; i < 9 ; i++ ){
	deg  = PMdegrees(radi[i]);
	degm = PMdegrng(deg);
	rad  = PMradians(degi[i]);
	radm = PMradrng(rad);
	printf("%10.4lf  %10.4lf  %10.4lf  %10.4lf  %10.4lf  %10.4lf\n",
	       radi[i],
	       deg,
	       degm,
	       degi[i],
	       rad,
	       radm);
    }
    printf("Angle conversion tests:\n");
    printf("   degrees\tPMpcfpd(deg)\tPMpdfpc(deg)\tTorture(deg)\t\n");
    for ( i = 0 ; i < 9 ; i++ ){
	rad = PMradians(PMdegrng(degcdi[i]));
	cen = PMdegrees(PMpcfpd(rad,.935));
	det = PMdegrees(PMpdfpc(rad,.935));
	tor =
	    PMdegrees(PMpcfpd(PMpdfpc(PMradians(PMdegrees(PMradians(PMdegrng(degcdi[i])))),
				  .935),
			    .935));
	printf("%10.4lf\t%10.4lf\t%10.4lf\t%10.4lf\n",
	       PMdegrng(degcdi[i]),
	       cen,
	       det,
	       tor);
    }

    return 0;
}
