/*---------------------------------------------------------------
           FILE: simplex.h
      $Revision: 2.0 $
         $State: Exp $
  Last submitted $Date: 93/03/30 18:06:34 $ $Author: jh $

   Locked out by $Locker: jh $

  REVISION HISTORY
  $Log:	simplex.h,v $
 * Revision 2.0  93/03/30  18:06:34  jh
 * Actual first release version.
 * 
 * Revision 1.2  93/03/30  13:55:47  jh
 * General code cleanup, testing, and added features.
 * First release version.
 * 
 * Revision 1.1  92/12/15  13:13:13  jh
 * Initial revision
 * 

  $Source: /u3/jh/jupobs92/anal/iraf/src/jiggle/RCS/simplex.h,v $

  Copyright (c) 1992, 1993 Joseph Harrington.
  All Rights reserved.
---------------------------------------------------------------*/
#ifndef SIMPLEX_PROTECT
#ifndef LINT
static char rcsidsimplexh[] = "$Header: /u3/jh/jupobs92/anal/iraf/src/jiggle/RCS/simplex.h,v 2.0 93/03/30 18:06:34 jh Exp Locker: jh $";
static char copyrightsimplexh[] =
    "Copyright (c) 1992, 1993 Joseph Harrington.  All Rights reserved.";
#endif
#endif

/*---------------------------------------------------------------
simplex.h = include file for simplex

---------------------------------------------------------------*/
#ifndef SIMPLEX_PROTECT
#define SIMPLEX_PROTECT

/* inclusions */
#include <stddef.h>

/* data types */

typedef struct {
    double       (*func)();  /* function to minimize: */
			     /* (func)( param->ptry, param->funcpars ) */
    void          *funcpars; /* pointer to parameter(s) to func */
    size_t         ndim;     /* number of dimensions in param->p[] */
    size_t         npts;     /* number of points in simplex */
    double       **p;        /* coordinates of simplex */
    double        *y;        /* func evaluated at the points in p */
    double        *psum;     /* sum of dimensions in p */
    double        *ptry;     /* point to try func at */
    double         ftol;     /* maximum distance from all points in the */
			     /* simplex to minimum point.  should not be */
			     /* less than machine precision.*/
    double         flip;     /* parameter for flipping hi vertex */
    double         extend;   /* parameter for extending hi vertex */
    double         contract; /* parameter for contracting hi vertex */
    unsigned int   funcmax;  /* maximum allowed function evaluations */
    unsigned int   nfunc;    /* function evaluation counter */
} Simplex_param;

/* prototypes */

#if defined(__STDC__) || defined(__cplusplus)
# define P_(s) s
#else
# define P_(s) ()
#endif


/* simplex.c */
void amoeba P_((double **p, double y[], size_t ndim, double ftol, double (*funk)(), unsigned int *nfunk));
Simplex_param *simplex P_((Simplex_param *param));
void simplex_calc_psum P_((Simplex_param *param));
double simplex_project P_((Simplex_param *param, size_t vert, double factor));
Simplex_param *simplex_create P_((size_t ndim));
Simplex_param *simplex_init_param P_((Simplex_param *param, double (*func )(), void *funcpars, double ftol, double flip, double extend, double contract, unsigned int funcmax));
Simplex_param *simplex_init_p P_((Simplex_param *param, double *p));
Simplex_param *simplex_init_point P_((Simplex_param *param, double side));
Simplex_param *simplex_init_simplex P_((Simplex_param *param, double **p, double y[]));
void simplex_free P_((Simplex_param *param));

#undef P_

#endif
